/******************************************************************************
|  File Name :  CanTp.c
|  Description: Manages segmenting of data in the send direction,
|               assembling of data in the receive direction,
|               and monitoring of the data stream.
|------------------------------------------------------------------------------
| (c) This software is the proprietary of Wenzhou Changjiang AutoMobile (DAMING)
|     All rights are reserved by DAMING.
|------------------------------------------------------------------------------
| Initials      Name                   Company
| --------      --------------------   ----------------------------------------
|                				       DAMING
|------------------------------------------------------------------------------
|               R E V I S I O N   H I S T O R Y
|------------------------------------------------------------------------------
| Date         Version    Author       Description
| ----------   --------   ------       ----------------------------------------
| 2015-9-1     V1.0       LZY          
 *****************************************************************************/
/*
TP  500us ڵļ֡ ǿǵAPP̵Ľ 
CANж̫ƵʱƬƫƣ֡  STminΪ5ms

ϱĽնԣ
֡  Ӧһ֡ Ӧʱǰ(1000 ms) ֡
֡  ɱ (֡) (֡֡)  
֡ Ϻ Ӧʱǰ(1000 ms) ֡



ϲӦĺTP㿪ʼµһ֡

ϲͨTP㷢ͱģTPΪѾӦǰġ( Ӧ 78⣬յ78Ӧ ӳ1S3ʱӦʱ 5S)

S3  յ  ϣԵ÷ͺΪ־ ӿΪ ACTIVE Ϊ INACTIVE

Ӧʱ䣺1S
TPռ10% APPռ90% 900ms APP뽫 TP ޷DL = 0
APP㳬ʱTP㽫ֹ֡ĵӦ ص״̬ ׼һ֡

78Ӧ ӳ1S3ʱӦʱ 5S
*/


 
 
/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/
//#include "global.h"
#include "CanTp.h"

/******************************************************************************
 * Description:     : Global Variable Definition Section 									
 ******************************************************************************/


/******************************************************************************
 * Description:     : Static Variable Definition Section 									
 ******************************************************************************/	

#define DAMING_TRUE     DCM_TRUE
#define DAMING_FALSE    DCM_FALSE
#define DAMING_ACTIVE   DCM_ACTIVE
#define DAMING_INACTIVE DCM_INACTIVE
static uint8 SaCanTp_u_RxSFBuffer[8]; /*֡buffer*/

static TeCanTp_e_TpSts   SeCanTp_e_TpSts;/*TP㹤״̬*/


static uint8 SeCanTp_u_BS;
static uint8 SeCanTp_u_STmin;

static uint8 SaCanTp_u_RxMFBuffer[CANTP_MFLEN_MAX];/*֡buffer*/

static uint16 SeCanTp_u_RxLen;
static TeCanTp_e_AddrMethod SeCanTp_e_AddrMethod;/*Ѱַʽ*/

static uint16 SeCanTp_u_RxMFDataCnt;
static uint8 SeCanTp_u_LastSN;

static uint16 SeCanTp_u_Timer;	
static TeCanTp_e_MFTimerSwitch SeCanTp_e_TimerSwitch;

static TeCanTp_e_TxSts SeCanTp_e_TxSts;/*״̬*/

static uint8 SaCanTp_u_TxDataBuffer[CANTP_MFLEN_MAX];
static uint8 SaCanTp_u_TxBuffer[8];

static uint16 SeCanTp_u_TxLen;

static uint16     SeCanTp_u_TxMFIndex;
static TeCanTp_e_MFTxSts SeCanTp_e_MFTxSts;
static uint8 SeCanTp_u_MFTxSN; 
static uint8 SeCanTp_u_MFTxSpacing;

static uint16 SeCanTp_w_RespTimer; /*ʱ*/
static uint8 SeCanTp_u_RespFlag;
/******************************************************************************
 * Description:     : Static Function Prototype Declaration									
 *****************************************************************************/
 
/******************************************************************************
 * Description:     : Write User Function Code								
 *****************************************************************************/

/******************************************************************************
 *    : 

 *        : TeCanTp_e_AddrMethod* LeCanTp_p_AddrMethod ,   Addressing Method
                uint16* LeCanTp_p_DL ,    Data Length
                uint8* LeCanTp_p_DataAddr        array of data pointer

 *ֵ      : 

 *        : get frame data 

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
TeCanTp_e_RxBufferSts GetCanTp_e_RxBufferSts(uint8* LeCanTp_p_AddrMethod , uint16* LeCanTp_p_DL , uint8** LeCanTp_p_DataAddr)
{
	TeCanTp_e_RxBufferSts LeCanTp_e_RxSts;
	
	if(SeCanTp_e_TpSts == CeCanTp_e_SF_Get)
	{
		SeCanTp_e_TpSts = CeCanTp_e_Answer;
		*LeCanTp_p_AddrMethod = SeCanTp_e_AddrMethod;
		*LeCanTp_p_DL = SeCanTp_u_RxLen;
		*LeCanTp_p_DataAddr = SaCanTp_u_RxSFBuffer;
		LeCanTp_e_RxSts = CeCanTp_e_Full;
	}
	else if(SeCanTp_e_TpSts == CeCanTp_e_MF_Get)
	{
		SeCanTp_e_TpSts = CeCanTp_e_Answer;
		*LeCanTp_p_AddrMethod = SeCanTp_e_AddrMethod;
		*LeCanTp_p_DL = SeCanTp_u_RxLen;
		*LeCanTp_p_DataAddr = SaCanTp_u_RxMFBuffer;
		LeCanTp_e_RxSts = CeCanTp_e_Full;
	}
	else
	{
		LeCanTp_e_RxSts = CeCanTp_e_Empty;
	}
	return LeCanTp_e_RxSts;
}
 
 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : CanIf TPݺ Ѱַ

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/

void RxIndicationCanTP_AddrPhy_Message(CanIf_HwHandleType LeCanTp_e_Hrh, 
									   CanIf_CanIdType    LeCanTp_e_CanId, 
									   CanIf_CanDlcType   LeCanTp_e_CanDlc, 
								 const CanIf_CanDataType  LeCanTp_e_CanSduPtr[])
{
	uint8 LeCanTp_u_FrameInfo = 0;
	uint8 LeCanTp_u_DataIndex;
	
	(void)LeCanTp_e_Hrh;
	(void)LeCanTp_e_CanDlc;
	
	if(LeCanTp_e_CanId == CANTP_ADDR_PHY_REQ)
	{
		LeCanTp_u_FrameInfo = LeCanTp_e_CanSduPtr[0] >> 4;
		 
		if((SeCanTp_e_TpSts == CeCanTp_e_SF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_MF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_Answer))/*ǰӦ*/
		{
			if((SeCanTp_e_TpSts == CeCanTp_e_Answer) && (SeCanTp_e_MFTxSts == CeCanTp_e_TX_FCWaiting))/*׶ Ͷ֡*/
			{
				if(LeCanTp_u_FrameInfo == 3)/*FC*/
				{
					if((LeCanTp_e_CanSduPtr[0]&0x0F) == 0x00)/*FSж */
					{
						SeCanTp_e_MFTxSts = CeCanTp_e_TX_CFGaving;
							
						if(LeCanTp_e_CanSduPtr[1] == 0)
						{
							SeCanTp_u_BS = CANTP_MFLEN_MAX;
						}
						else
						{
							SeCanTp_u_BS = LeCanTp_e_CanSduPtr[1];
						}
							
						if(SeCanTp_u_STmin < 0x7FU)
						{
							SeCanTp_u_STmin = ((LeCanTp_e_CanSduPtr[2]-1)/CANTP_TASK)+1;
						}
						else
						{
							SeCanTp_u_STmin = 0;
						}
							
						SeCanTp_u_MFTxSpacing = 0;/*ʼСʱ*/
						SeCanTp_u_Timer = 0;
					}
					else if((LeCanTp_e_CanSduPtr[0]&0x0F) == 0x01)/*FSж ȴ*/
					{
						/*ȴ ռʱ ٵһ bs*/
						SeCanTp_u_Timer = 0;
					}
					else
					{
						/*ض֡*/
						SeCanTp_e_MFTxSts = CeCanTp_e_TX_Idel;
						SeCanTp_e_TpSts = CeCanTp_e_Idel;
						SeCanTp_e_TxSts = CeCanTp_e_Tx_Idle;
					}
				}
			}
			else{/*֡*/}
		}
		else
		{
			if(LeCanTp_u_FrameInfo == 0)/*SF*/
			{
				SeCanTp_u_RxLen = LeCanTp_e_CanSduPtr[0]&0x0f;
				if((SeCanTp_u_RxLen < 8) && (SeCanTp_u_RxLen > 0))
				{
					SeCanTp_e_TpSts = CeCanTp_e_SF_Get;/*֡*/
					
					SeCanTp_e_AddrMethod = CeCanTp_e_Physical;
					for(LeCanTp_u_DataIndex = 0;LeCanTp_u_DataIndex < SeCanTp_u_RxLen;LeCanTp_u_DataIndex++)
					{
						SaCanTp_u_RxSFBuffer[LeCanTp_u_DataIndex] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex+1];
					}
					
					SeCanTp_u_RespFlag = DAMING_TRUE;
					SeCanTp_w_RespTimer = 1000U;
				}
				else
				{/*֡*/}
			}
			else if(LeCanTp_u_FrameInfo == 1)/*FF*/ 
			{
				SeCanTp_u_RxLen =(uint16)(((uint16)(LeCanTp_e_CanSduPtr[0] & 0x0f) << 8) + (uint16)LeCanTp_e_CanSduPtr[1]);
				if(SeCanTp_u_RxLen > CANTP_MFLEN_MAX)		// add for 15765-2-6.5.2.2 
				{
					/*֡*/
					/*ֱӻظ֡*/
					SaCanTp_u_TxBuffer[0] = 0x30;
					SaCanTp_u_TxBuffer[1] = 2;
					SaCanTp_u_TxBuffer[2] = CANTP_RX_STMIN;
					
					TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
				}
				else if(SeCanTp_u_RxLen > 7)
				{
					SeCanTp_e_AddrMethod = CeCanTp_e_Physical;
						
					/*ö֡*/
					SeCanTp_u_RxMFDataCnt = 0;
						
					/*ǰ6*/
					for(LeCanTp_u_DataIndex = 2;LeCanTp_u_DataIndex < 8;LeCanTp_u_DataIndex++)
					{
						SaCanTp_u_RxMFBuffer[SeCanTp_u_RxMFDataCnt] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex];
						SeCanTp_u_RxMFDataCnt++;
					}
					SeCanTp_u_LastSN = 1;
					
					/*ֱӻظ֡*/
					SaCanTp_u_TxBuffer[0] = 0x30;
					SaCanTp_u_TxBuffer[1] = 0;
					SaCanTp_u_TxBuffer[2] = CANTP_RX_STMIN;
					
					TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
					
					SeCanTp_e_TpSts = CeCanTp_e_MF_CFTakein;/*ȴպ֡*/
					
					SeCanTp_e_TimerSwitch = CeCanTp_e_Cr;
					SeCanTp_u_Timer = 0;
				}
				else
				{/*֡*/}
			}
			else if(LeCanTp_u_FrameInfo == 2)/*CF*/	 
			{
				if(SeCanTp_e_TpSts == CeCanTp_e_MF_CFTakein)
				{
					/*SN*/
					SeCanTp_u_Timer = 0;
					
					if((LeCanTp_e_CanSduPtr[0]&0x0F) == (SeCanTp_u_LastSN & 0x0F))
					{
						/**/
						SeCanTp_u_LastSN++;
						if((LeCanTp_e_CanDlc < 8)&&(LeCanTp_e_CanDlc >0)&&(SeCanTp_u_RxMFDataCnt < (SeCanTp_u_RxLen - LeCanTp_e_CanDlc)))
						{
							SeCanTp_e_TpSts = CeCanTp_e_Idel;	// DLC  
						}
						else
						{						
							for(LeCanTp_u_DataIndex = 1;LeCanTp_u_DataIndex < 8;LeCanTp_u_DataIndex++)
							{
								if(SeCanTp_u_RxMFDataCnt < SeCanTp_u_RxLen)
								{
									SaCanTp_u_RxMFBuffer[SeCanTp_u_RxMFDataCnt] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex];
									SeCanTp_u_RxMFDataCnt++;
								}
								else
								{
									/*ݽ*/
									SeCanTp_e_TpSts = CeCanTp_e_MF_Get;
									
									SeCanTp_u_RespFlag = DAMING_TRUE;
									SeCanTp_w_RespTimer = 1000U;
									break;
								}
								
								if(SeCanTp_u_RxMFDataCnt == SeCanTp_u_RxLen)
								{
									/*ݽ*/
									SeCanTp_e_TpSts = CeCanTp_e_MF_Get;
									
									SeCanTp_u_RespFlag = DAMING_TRUE;
									SeCanTp_w_RespTimer = 1000U;
									break;
								}
							}
						}
						
					}
					else
					{
						/*SN ֡*/
						SeCanTp_e_TpSts = CeCanTp_e_Idel;
					}
				}
				else
				{
					/*ǰ ֡ܺ֡׶ ֡*/
				}
			}
			else
			{
				/* ֡  ״̬֡*/
			}
		}
	}
	else
	{
		
	}
}
 
  /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : CanIf TPݺ Ѱַ

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
#if (CANTP_ADDRFUNC_MF_FORBID == DAMING_TRUE)
void RxIndicationCanTP_AddrFunc_Message(CanIf_HwHandleType LeCanTp_e_Hrh, 
									    CanIf_CanIdType    LeCanTp_e_CanId, 
									    CanIf_CanDlcType   LeCanTp_e_CanDlc, 
								  const CanIf_CanDataType  LeCanTp_e_CanSduPtr[])
{
	uint8 LeCanTp_u_FrameInfo = 0;
	uint8 LeCanTp_u_DataIndex;
	
	(void)LeCanTp_e_Hrh;
	(void)LeCanTp_e_CanDlc;
	
	if(LeCanTp_e_CanId == CANTP_ADDR_FUNC_REQ)
	{
		LeCanTp_u_FrameInfo = LeCanTp_e_CanSduPtr[0] >> 4;
		 
		if((SeCanTp_e_TpSts == CeCanTp_e_SF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_MF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_Answer))/*ǰӦ*/
		{
			if((SeCanTp_e_TpSts == CeCanTp_e_Answer) && (SeCanTp_e_MFTxSts == CeCanTp_e_TX_FCWaiting))/*׶ Ͷ֡*/
			{
				if(LeCanTp_u_FrameInfo == 3)/*FC*/
				{
					if((LeCanTp_e_CanSduPtr[0]&0x0F) == 0x00)/*FSж */
					{
						SeCanTp_e_MFTxSts = CeCanTp_e_TX_CFGaving;
							
						if(LeCanTp_e_CanSduPtr[1] == 0)
						{
							SeCanTp_u_BS = CANTP_MFLEN_MAX;
						}
						else
						{
							SeCanTp_u_BS = LeCanTp_e_CanSduPtr[1];
						}
							
						if(SeCanTp_u_STmin < 0x7FU)
						{
							SeCanTp_u_STmin = ((LeCanTp_e_CanSduPtr[2]-1)/CANTP_TASK)+1;
						}
						else
						{
							SeCanTp_u_STmin = 0;
						}
							
						SeCanTp_u_MFTxSpacing = 0;/*ʼСʱ*/
					}
					else if((LeCanTp_e_CanSduPtr[0]&0x0F) == 0x01)/*FSж ȴ*/
					{
						/*ȴ ռʱ ٵһ bs*/
						SeCanTp_u_Timer = 0;
					}
					else
					{
						/*ض֡*/
						SeCanTp_e_MFTxSts = CeCanTp_e_TX_Idel;
						SeCanTp_e_TpSts = CeCanTp_e_Idel;
						SeCanTp_e_TxSts = CeCanTp_e_Tx_Idle;
					}
				}
			}
		}
		else
		{
			if(LeCanTp_u_FrameInfo == 0)/*SF*/
			{
				SeCanTp_u_RxLen = LeCanTp_e_CanSduPtr[0]&0x0f;
				if((SeCanTp_u_RxLen < 8) && (SeCanTp_u_RxLen > 0))
				{
					SeCanTp_e_TpSts = CeCanTp_e_SF_Get;/*֡*/
					
					SeCanTp_e_AddrMethod = CeCanTp_e_Functional;
					for(LeCanTp_u_DataIndex = 0;LeCanTp_u_DataIndex < SeCanTp_u_RxLen;LeCanTp_u_DataIndex++)
					{
						SaCanTp_u_RxSFBuffer[LeCanTp_u_DataIndex] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex+1];
					}
					
					SeCanTp_u_RespFlag = DAMING_TRUE;
					SeCanTp_w_RespTimer = 1000U;
				}
				else
				{/*֡*/}
			}

			else if(LeCanTp_u_FrameInfo == 1)/*FF*/ 
			{
				SeCanTp_u_RxLen =(uint16)(((uint16)(LeCanTp_e_CanSduPtr[0] & 0x0f) << 8) + (uint16)LeCanTp_e_CanSduPtr[1]);
				
				if(SeCanTp_u_RxLen > 7)
				{
					SeCanTp_e_AddrMethod = CeCanTp_e_Functional;
						
					/*ö֡*/
					//SeCanTp_u_RxLen =(uint16)(((uint16)(LeCanTp_e_CanSduPtr[0] & 0x0f) << 8) + (uint16)LeCanTp_e_CanSduPtr[1]);
					SeCanTp_u_RxMFDataCnt = 0;
						
					/*ǰ6*/
					for(LeCanTp_u_DataIndex = 2;LeCanTp_u_DataIndex < 8;LeCanTp_u_DataIndex++)
					{
						SaCanTp_u_RxMFBuffer[SeCanTp_u_RxMFDataCnt] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex];
						SeCanTp_u_RxMFDataCnt++;
					}
					SeCanTp_u_LastSN = 1;
					
					/*ֱӻظ֡*/
					SaCanTp_u_TxBuffer[0] = 0x30;
					SaCanTp_u_TxBuffer[1] = 0;
					SaCanTp_u_TxBuffer[2] = CANTP_RX_STMIN;
					
					TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
					
					SeCanTp_e_TpSts = CeCanTp_e_MF_CFTakein;/*ȴպ֡*/
					
					SeCanTp_e_TimerSwitch = CeCanTp_e_Cr;
					SeCanTp_u_Timer = 0;
				}
				else
				{/*֡*/}
			}
			else if(LeCanTp_u_FrameInfo == 2)/*CF*/	 
			{
				if(SeCanTp_e_TpSts == CeCanTp_e_MF_CFTakein)
				{
					/*SN*/
					if((LeCanTp_e_CanSduPtr[0]&0x0F) == ((SeCanTp_u_LastSN+1)&0x0F))
					{
						/**/
						SeCanTp_u_LastSN++;
						
						for(LeCanTp_u_DataIndex = 1;LeCanTp_u_DataIndex < 8;LeCanTp_u_DataIndex++)
						{
							if(SeCanTp_u_RxMFDataCnt < SeCanTp_u_RxLen)
							{
								SaCanTp_u_RxMFBuffer[SeCanTp_u_RxMFDataCnt] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex];
								SeCanTp_u_RxMFDataCnt++;
							}
							else
							{
								/*ݽ*/
								SeCanTp_e_TpSts = CeCanTp_e_MF_Get;
								
								SeCanTp_u_RespFlag = DAMING_TRUE;
								SeCanTp_w_RespTimer = 1000U;
								break;
							}
							
							if(SeCanTp_u_RxMFDataCnt == SeCanTp_u_RxLen)
							{
								/*ݽ*/
								SeCanTp_e_TpSts = CeCanTp_e_MF_Get;
								
								SeCanTp_u_RespFlag = DAMING_TRUE;
								SeCanTp_w_RespTimer = 1000U;
								break;
							}
						}
					}
					else
					{
						/*SN ֡*/
						SeCanTp_e_TpSts = CeCanTp_e_Idel;
					}
				}
				else
				{
					/*ǰ ֡ܺ֡׶ ֡*/
				}
			}
			else
			{
				/* ֡  ״̬֡*/
			}
		}
	}
	else
	{}
}
#else  
void RxIndicationCanTP_AddrFunc_Message(CanIf_HwHandleType LeCanTp_e_Hrh, 
									    CanIf_CanIdType    LeCanTp_e_CanId, 
									    CanIf_CanDlcType   LeCanTp_e_CanDlc, 
								  const CanIf_CanDataType  LeCanTp_e_CanSduPtr[])
{
	uint8 LeCanTp_u_FrameInfo = 0;
	uint8 LeCanTp_u_DataIndex;
	
	(void)LeCanTp_e_Hrh;
	(void)LeCanTp_e_CanDlc;
	
	if(LeCanTp_e_CanId == CANTP_ADDR_FUNC_REQ)
	{
		LeCanTp_u_FrameInfo = LeCanTp_e_CanSduPtr[0] >> 4;
		 
		if((SeCanTp_e_TpSts == CeCanTp_e_SF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_MF_Get)/*ѽյ֡*/
			||(SeCanTp_e_TpSts == CeCanTp_e_Answer))/*ǰӦ*/
		{
			/*֡*/
		}
		else
		{
			if(LeCanTp_u_FrameInfo == 0)/*SF*/
			{
				SeCanTp_u_RxLen = LeCanTp_e_CanSduPtr[0]&0x0f;
				if(SeCanTp_u_RxLen < 8)
				{
					SeCanTp_e_TpSts = CeCanTp_e_SF_Get;/*֡*/
					
					SeCanTp_e_AddrMethod = CeCanTp_e_Functional;
					for(LeCanTp_u_DataIndex = 0;LeCanTp_u_DataIndex < SeCanTp_u_RxLen;LeCanTp_u_DataIndex++)
					{
						SaCanTp_u_RxSFBuffer[LeCanTp_u_DataIndex] = LeCanTp_e_CanSduPtr[LeCanTp_u_DataIndex+1];
					}
					
					SeCanTp_u_RespFlag = DAMING_TRUE;
					SeCanTp_w_RespTimer = 1000U;
				}
				else
				{/*֡*/}
			}
		}
	}
	else
	{}
}  
#endif

 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : 

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
TeCanTp_e_TxResult SetCanTp_TxBuffer(uint16 LeCanTp_p_DL , const uint8 LeCanTp_p_DataAddr[])
{
	TeCanTp_e_TxResult LeCanTp_e_TxResult;
	uint16 LeCanTp_s_Index;
	
	/*ֻڷ׶ Է*/
	if ((SeCanTp_e_TpSts == CeCanTp_e_Answer) && (SeCanTp_e_TxSts == CeCanTp_e_Tx_Idle))
	{
		SeCanTp_u_RespFlag = DAMING_FALSE;
		SeCanTp_w_RespTimer = 1000U;
		
		if(LeCanTp_p_DL == 0)
		{
			/*ñ޷*/
			SeCanTp_e_TpSts = CeCanTp_e_Idel;
		}
		else if(LeCanTp_p_DL < 8)
		{
			/*֡ ֱӷ*/
			SaCanTp_u_TxBuffer[0] = (uint8)LeCanTp_p_DL;
			
			for(LeCanTp_s_Index = 1; LeCanTp_s_Index < 8; LeCanTp_s_Index++)
			{
				SaCanTp_u_TxBuffer[LeCanTp_s_Index] = 0x55;
			}
			
			for(LeCanTp_s_Index = 0; LeCanTp_s_Index < LeCanTp_p_DL; LeCanTp_s_Index++)
			{
				SaCanTp_u_TxBuffer[LeCanTp_s_Index + 1] = LeCanTp_p_DataAddr[LeCanTp_s_Index];
			}
			
			TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
			
			SeCanTp_e_TpSts = CeCanTp_e_Idel;		
		}
		else
		{
			/*֡*/
			SeCanTp_e_TxSts = CeCanTp_e_Tx_Busy;
			
			/*ȡ*/
			for(LeCanTp_s_Index = 0; LeCanTp_s_Index < LeCanTp_p_DL; LeCanTp_s_Index++)
			{
				SaCanTp_u_TxDataBuffer[LeCanTp_s_Index] = LeCanTp_p_DataAddr[LeCanTp_s_Index];
			}
			
			SeCanTp_u_TxLen = LeCanTp_p_DL;
			
			
			/*֡*/
			SaCanTp_u_TxBuffer[0] = 0x10 + (uint8)(LeCanTp_p_DL >> 8);
			SaCanTp_u_TxBuffer[1] = (uint8)(LeCanTp_p_DL & 0x00ff);
			

			for(SeCanTp_u_TxMFIndex = 0; SeCanTp_u_TxMFIndex < 6; SeCanTp_u_TxMFIndex++)
			{
				SaCanTp_u_TxBuffer[SeCanTp_u_TxMFIndex+2] = SaCanTp_u_TxDataBuffer[SeCanTp_u_TxMFIndex];
			}
			TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
			
	        SeCanTp_e_TimerSwitch = CeCanTp_e_Bs;
			SeCanTp_u_Timer = 0;
			
			SeCanTp_u_MFTxSN = 1;
			SeCanTp_e_MFTxSts = CeCanTp_e_TX_FCWaiting;
		}
		
		LeCanTp_e_TxResult = CeCanTp_e_Tx_Succeed;
	}
	else
	{
		LeCanTp_e_TxResult = CeCanTp_e_Tx_Wrong;
	}
	
	return LeCanTp_e_TxResult;
}
  
 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : 78Ӧ  Ӧ жϵǰ 

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
TeCanTp_e_TxResult SetCanTp_Tx_78Neg(uint16 LeCanTp_p_DL , const uint8 LeCanTp_p_DataAddr[])
{
	TeCanTp_e_TxResult LeCanTp_e_TxResult;
	uint8 LeCanTp_u_Index;
	
	/*ֻڷ׶ Է*/
	if ((SeCanTp_e_TpSts == CeCanTp_e_Answer) && (SeCanTp_e_TxSts == CeCanTp_e_Tx_Idle))
	{
		if(LeCanTp_p_DL < 8)
		{
			/*֡ ֱӷ*/
			SaCanTp_u_TxBuffer[0] = (uint8)LeCanTp_p_DL;
			
			for(LeCanTp_u_Index = 1; LeCanTp_u_Index < 8; LeCanTp_u_Index++)
			{
				SaCanTp_u_TxBuffer[LeCanTp_u_Index] = 0x55;
			}
			
			for(LeCanTp_u_Index = 0; LeCanTp_u_Index < LeCanTp_p_DL; LeCanTp_u_Index++)
			{
				SaCanTp_u_TxBuffer[LeCanTp_u_Index + 1] = LeCanTp_p_DataAddr[LeCanTp_u_Index];
			}
			
			TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
				
			LeCanTp_e_TxResult = CeCanTp_e_Tx_Succeed;		
			
			SeCanTp_w_RespTimer = 0u;
		}
		else
		{
			LeCanTp_e_TxResult = CeCanTp_e_Tx_Wrong;
		}
	}
	else
	{
		LeCanTp_e_TxResult = CeCanTp_e_Tx_Wrong;
	}
	
	return LeCanTp_e_TxResult;
}


 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : 

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
void InitCanTp_Parameter(void)
{
	uint8 LeCanTp_u_InitIndex;
	
	for(LeCanTp_u_InitIndex = 0; LeCanTp_u_InitIndex<8 ; LeCanTp_u_InitIndex++)
	{
		SaCanTp_u_RxSFBuffer[LeCanTp_u_InitIndex] = 0;/*֡buffer*/
		SaCanTp_u_TxBuffer[LeCanTp_u_InitIndex] = 0;
		SaCanTp_u_TxDataBuffer[LeCanTp_u_InitIndex] = 0;
		SaCanTp_u_RxMFBuffer[LeCanTp_u_InitIndex] = 0;/*֡buffer*/
	}
	
	SeCanTp_e_TpSts = CeCanTp_e_Idel;/*TP㹤״̬*/

	SeCanTp_u_BS = 0;
	SeCanTp_u_STmin = 10;

	
	SeCanTp_u_RxLen = 0;
	SeCanTp_e_AddrMethod = CeCanTp_e_Physical;/*Ѱַʽ*/

	SeCanTp_u_RxMFDataCnt = 0;
	SeCanTp_u_LastSN = 0;

	SeCanTp_u_Timer = 0;	
	SeCanTp_e_TimerSwitch = 0;

	SeCanTp_e_TxSts = CeCanTp_e_Tx_Idle;/*״̬*/

	SeCanTp_u_TxLen = 0;

	SeCanTp_u_TxMFIndex = 0;
	SeCanTp_e_MFTxSts = CeCanTp_e_TX_Idel;
	
	SeCanTp_u_MFTxSN = 0; 
	SeCanTp_u_MFTxSpacing = 0;

	SeCanTp_w_RespTimer = 1000U; /*ʱ*/
	SeCanTp_u_RespFlag = DAMING_FALSE;
}
  
  
  
  
 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        :  ڷ ֡  سʱʱ

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
void MngCanTp_MainFunction(void)
{
	uint8 LeCanTp_u_Index;
	
	if(SeCanTp_e_TpSts == CeCanTp_e_MF_CFTakein)/*ʱ*/
	{
		if(SeCanTp_e_TimerSwitch == CeCanTp_e_Cr)
		{
			if(SeCanTp_u_Timer > CANTP_CR_TIMEOUT)
			{
				/*ʱ*/
				SeCanTp_e_TpSts = CeCanTp_e_Idel;
			}
			else
			{
				SeCanTp_u_Timer++;
			}
		}
		else
		{
			SeCanTp_e_TimerSwitch = CeCanTp_e_Cr;
			SeCanTp_u_Timer = 0;
		}
	}
	else
	{
		
	}
	
	if(SeCanTp_u_RespFlag == DAMING_TRUE)/*APPʱ*/
	{
		if(SeCanTp_w_RespTimer > CANTP_APP_RESP_78NEG)
		{
			/*ʱ*/
			SeCanTp_e_TpSts = CeCanTp_e_Idel;
			
			SeCanTp_u_RespFlag = DAMING_FALSE;
			
			SeCanTp_w_RespTimer = 1000U;
		}
		else
		{
			SeCanTp_w_RespTimer++;
		}
	}
	else
	{
		SeCanTp_w_RespTimer = 1000U;
	}
	
	if(SeCanTp_e_TpSts == CeCanTp_e_Answer)
	{
		if(SeCanTp_e_MFTxSts == CeCanTp_e_TX_FCWaiting)/*FCȴʱ*/
		{
			if(SeCanTp_e_TimerSwitch == CeCanTp_e_Bs)
			{
				if(SeCanTp_u_Timer > CANTP_BS_TIMEOUT)
				{
					/*ʱ*/
					SeCanTp_e_MFTxSts = CeCanTp_e_TX_Idel;
					SeCanTp_e_TpSts = CeCanTp_e_Idel;
					SeCanTp_e_TxSts = CeCanTp_e_Tx_Idle;	
				}
				else
				{
					SeCanTp_u_Timer++;
				}
			}
			else
			{
				SeCanTp_e_TimerSwitch = CeCanTp_e_Bs;
				SeCanTp_u_Timer = 0;
			}
		}
		else
		{}

		if(SeCanTp_e_MFTxSts == CeCanTp_e_TX_CFGaving)/**/
		{
			/*CF*/
			SeCanTp_u_MFTxSpacing++;
			
			if(SeCanTp_u_BS > 0)
			{
				if(SeCanTp_u_MFTxSpacing > SeCanTp_u_STmin)
				{
					SeCanTp_u_MFTxSpacing = 1;
					if(SeCanTp_u_TxMFIndex < (SeCanTp_u_TxLen-7))
					{
						SaCanTp_u_TxBuffer[0] = 0x20 + SeCanTp_u_MFTxSN;
						
						for(LeCanTp_u_Index = 0; LeCanTp_u_Index < 7; LeCanTp_u_Index++)
						{
							SaCanTp_u_TxBuffer[LeCanTp_u_Index + 1] = SaCanTp_u_TxDataBuffer[SeCanTp_u_TxMFIndex++];
						}
						TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
						
						SeCanTp_u_MFTxSN += 1;
						SeCanTp_u_MFTxSN &= 0x0f;
						
						if(SeCanTp_u_BS == 1u)
						{
							SeCanTp_e_MFTxSts = CeCanTp_e_TX_FCWaiting;/*֡*/
							SeCanTp_u_Timer = 0;
							SeCanTp_e_TimerSwitch = CeCanTp_e_Bs;
						}
						else
						{
							SeCanTp_u_BS--;
						}
					}
					else
					{
						/*һ֡*/
						uint8 LeCanTp_u_Cnt = SeCanTp_u_TxLen - SeCanTp_u_TxMFIndex;
						
						SaCanTp_u_TxBuffer[0] = 0x20 + SeCanTp_u_MFTxSN;
						
						for(LeCanTp_u_Index = 1; LeCanTp_u_Index < 8; LeCanTp_u_Index++)
						{
							SaCanTp_u_TxBuffer[LeCanTp_u_Index] = 0x55;
						}
						
						for(LeCanTp_u_Index = 0; LeCanTp_u_Index < LeCanTp_u_Cnt; LeCanTp_u_Index++)
						{ 
							SaCanTp_u_TxBuffer[LeCanTp_u_Index + 1] = SaCanTp_u_TxDataBuffer[SeCanTp_u_TxMFIndex++];
						}
						TransmitCanIf_Buffer(CANTP_RESP_CANID,8,SaCanTp_u_TxBuffer);
						
						SeCanTp_e_MFTxSts = CeCanTp_e_TX_Idel;
						SeCanTp_e_TpSts = CeCanTp_e_Idel;
						SeCanTp_e_TxSts = CeCanTp_e_Tx_Idle;
						
						SeCanTp_u_BS = 0;
					}
				}
				else
				{}
			}
			else
			{
				SeCanTp_e_MFTxSts = CeCanTp_e_TX_FCWaiting;/*֡*/
				SeCanTp_u_Timer = 0;
				SeCanTp_e_TimerSwitch = CeCanTp_e_Bs;
			}	
		}
		else
		{
			
		}
	}
	else
	{
		
	}
}

 /******************************************************************************
 *    : 

 *        : 

 *ֵ      : 

 *        : S3 ״̬
				S3  յ  ϣԵ÷ͺΪ־ ӿΪ DAMING_ACTIVE Ϊ DAMING_INACTIVE

 *༭ʱ    : 

 *ע        : 
 *****************************************************************************/
uint8 GetCanTp_u_S3Sts(void)
{
	uint8 LeCanTp_u_Ret;
	
	if(SeCanTp_e_TpSts == CeCanTp_e_Idel)
	{
		LeCanTp_u_Ret = DAMING_ACTIVE;
	}
	else
	{
		LeCanTp_u_Ret = DAMING_INACTIVE;
	}
	
	return LeCanTp_u_Ret;
}
