/*@处根据实际情况填写相关信息，将@字符以及这条提示语句去掉*/
/******************************************************************************
|  File Name :  @文件名
|  Description: @文件描述
******************************************************************************/
#ifndef CANTP_CFG_H
#define CANTP_CFG_H

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/
#include "DCM_Types.h"
//#include "CanIf.h"
#include "CanIf_cfg.h"

/******************************************************************************
 * Description:     : Macro Description Section
******************************************************************************/
/*@define类型定义*/
#define CANTP_TASK           1
#define CANTP_MFLEN_MAX      1200   /* 多帧最大长度 */



#define CANTP_ADDR_FUNC_REQ  0x7DF  /* 诊断功能寻址 */
#define CANTP_ADDR_PHY_REQ   0x741//0x7C6  /* 诊断物理寻址 */

#define CANTP_RESP_CANID  0x751//0x7CE     /* 诊断反馈 */



#define CANTP_ADDRFUNC_MF_FORBID     DCM_FALSE

#define CANTP_RX_STMIN_DEFINE             0x0A     /* STmin */


#define CANTP_AS_TIMEOUT_DEFINE         25u	/* 25ms?*/
#define CANTP_BS_TIMEOUT_DEFINE 		 75u	/* 75ms? */



#define CANTP_CS_TIMEOUT_DEFINE 		 	/*(N_Cs + N_As) < 0.9*N_Bs */
#define CANTP_AR_TIMEOUT_DEFINE 		 25u	/* 25ms? */

#define CANTP_BR_TIMEOUT_DEFINE 		 	/* (N_Br + N_Ar) < 0.9*N_Cr */
#define CANTP_CR_TIMEOUT_DEFINE 		 150u	/* 150ms */


  
#define CANTP_RESP_TIMEOUT_DEFINE       500u

#define CANTP_APP_RESP_TIMEOUT_DEFINE       500u /* APP响应时间 */
#define CANTP_APP_RESP_78NEG_DEFINE      5000u /* 78负相应 */


extern const CanIf_CanIdType  CANTP_ADDR_PHY_REQ_const ;
extern const CanIf_CanIdType  CANTP_ADDR_FUNC_REQ_const ;
extern const CanIf_CanIdType  CANTP_RESP_CANID_const ;
extern const uint8 CANTP_RX_STMIN;
extern const uint16 CANTP_BS_TIMEOUT;
extern const uint16 CANTP_CR_TIMEOUT;
extern const uint16 CANTP_APP_RESP_78NEG;
extern const unsigned char TP_DUMMY;//	0xAA

/******************************************************************************
 * Description:     : Structure Type Declaration Section
******************************************************************************/
/*@结构类型typedef定义*/


/******************************************************************************
 * Description:     : Global Variable Declaration Section
******************************************************************************/
/*@全局变量声明extern*/

/******************************************************************************
 * Description:     : Global Function Prototype Declaration	
******************************************************************************/
/*@接口函数声明extern*/

#endif
