
/******************************************************************************
|  File Name :  Dcm_App.h
|  Description: 
******************************************************************************/
#ifndef DCM_APP_H
#define DCM_APP_H

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/

#include "Dcm_App_Cfg.h"
/******************************************************************************
 * Description:     : Macro Description Section
******************************************************************************/
#define SetMcu_SoftReset() 	do{WDTE = 0;}while(1)


#define DCM_PHYSICAL_ADDRESS                      0x01          /*궨Ѱַʽ*/
#define DCM_FUNCTIONAL_ADDRESS                    0x02

#define DCM_DEFAULT_SESSION                       0x01       /*Ĭģʽ*/
#define DCM_PROGRAMME_SESSION                     0x02       /*ģʽ*/
#define DCM_EXTEND_SESSION                        0x04       /*չģʽ*/
#define DCM_DIAGNOSTIC_SESSION_DEFAULT             DCM_DEFAULT_SESSION             /*ϵĬϻỰģʽ*/

#define DCM_SECURITYACCESS_L2_UNLOCK              0x07       /*״̬*/
#define DCM_SECURITYACCESS_L1_UNLOCK              0x06        /*L1״̬*/
#define DCM_SECURITYACCESS_DEFAULT                0x04        /*Ĭϰȫ״̬״̬*/

#define DCM_SECURITY_LEVEL_DEFAULT				0x07
#define DCM_SECURITYACCESS_LEVEL_L1				0x03
#define DCM_SECURITYACCESS_LEVEL_L2				0x01

#define DCM_19SUPMASK                            0x09           /*19Ч*/
#define DCM_15031_6_DTCFORMAT                     0x00           /*DTCʽ*/

#define DCM_DTCSET_ENABLE                         1U        /*DTCʹ*/
#define DCM_DTCSET_DISENABLE                      0U        /*DTCùر*/

#define DCM_MSGTXRX_ENABLE                        1U        /*շ״̬ ʹ*/
#define DCM_MSGTXRX_DISENABLE                     0U        /*շ״̬ ر*/

#define DCM_SASERVERSTS_DEFAULT                  0U       /*27״̬ Ĭ״̬ ʼ״̬*/
#define DCM_SASERVERSTS_REQUESTKEY               (0x80)//1U       /*27״̬ */ 
#define DCM_SASERVERSTS_UNLOCK                   2U       /*27״̬ ѽ*/ 
#define DCM_SASERVERSTS_ERROR                    4U       /*27״̬ Կʱ*/ 


#define DCM_S3SEVERTIMER_STOP                     0U           /*S3ServerTime ʱֹͣ*/
#define DCM_S3SEVERTIMER_CONTINUE                 1U           /*S3ServerTime ʱ*/

#define DCM_DTCDATA_MAXLENGTH                     36           /*DTCб*/

#define DCM_TXBUFFER_LENGTH                       105U      /*bufferĳ*/          

#define DCM_SASERVER_KEYLENGTH                   4U      /*Կ*/
#define DCM_SASERVER_KEYERRORCOUNT               3U      /*Կ*/

#define DCM_RIDRESULT_SUCCESS                    0x04      /*̴ɹ*/
#define DCM_RIDRESULT_FAILURE                    0x05      /*̴ʧ*/

#define DCM_RIDRUNSTS_FINISH					 0x01
#define DCM_RIDRUNSTS_IDLE					 	 0x00

#define DCM_READDID_MAXNUMBER                     5U        /*22 һԶȡDID */ 
#define DCM_WRITEDATA_MAXLENGTH                   20U        /*2Eд󳤶*/



#define DCM_SASERVERSTS_ERRORDELAY_COUNT          10000U   /*Կʱ*/ 
#define DCM_SASERVERSTS_ERRORDELAY_COUNT_DEFAULT  10000U   /*Կʱ ϵĬֵ*/  

#define DCM_S3SEVERTIMEOUT                       5000U       /*S3ServerTimeʱʱ궨*/ 


#define DCM_DATAFOMATLDENTIFER                         0x00           /*34   ݸʽ*/ 
#define DCM_ADDRESSANDLENGTHFOMATLDENTIFER             0x44           /*34   ַݳȸʽ*/ 
#define DCM_DOWNLOAD_MINADDRESS                        0x00000000     /*34   Сַ*/
#define DCM_DOWNLOAD_MAXADDRESS                        0xFFFFFFFF     /*34   ַ*/
#define DCM_DOWNLOAD_MAXDATALENGTH                     0xFFF          /*34   ݳ*/
#define DCM_LENGTHFOMATLDENTIFER                       0x20           /*34   Ӧ ݳȸʽ*/ 
#define DCM_DOWNLOAD_RECEIVEDATALENGTH                 0x0400         /*36  ݻ鳤*/

/******************************************************************************
 * Description:     : Structure Type Declaration Section
******************************************************************************/
/*@ṹtypedef*/
/*34 36 37  ط״̬*/
typedef enum
{
  CeDcm_e_DownLoadRelax =0,
  CeDcm_e_DownLoadRequested,
  CeDcm_e_DownLoadDuringTransmit,
  CeDcm_e_DownLoadTransmited
}TeDcm_e_DownLoadStsType;

/*̿״̬*/
typedef enum
{
  CeDcm_e_RidStart =0,
  CeDcm_e_RidStop,
  CeDcm_e_RidGetResult
}TeDcm_e_RidStsType;

typedef enum
{
	Rid_Idle,
	Rid_Finish
}RidRunSts_T;

/*TPݷּϢ Ϣ*/
typedef struct
{
  uint16 DL;               						/*Чֽڳ*/
  uint8  Sid;              						/*SID*/
  uint8  RequstSty;        						/*ʽ*/
  uint8 Sub;               						/*ӷ*/
  uint8 DtcGroup[3];                  			/*DTC*/
  uint8 StateMask;                   			/* ״̬*/
  uint8 Key[DCM_SASERVER_KEYLENGTH];            /*ԿϢ*/
  uint8 CommType;                    			/*ͨѶ*/
  uint8 Did[DCM_READDID_MAXNUMBER*2];      		/*DID*/
  uint8 DidCount;                    			/*DID*/
  uint16 Rid;                     				/*RID*/
  uint8 WriteData[DCM_WRITEDATA_MAXLENGTH];     /*д*/
}TsDcm_h_RquestInfo;     

typedef enum{
	DCM_RESET_NOTREADY,
	DCM_RESET_READY
}DcmReset_T;

/******************************************************************************
 * Description:     : Global Variable Declaration Section
******************************************************************************/

/**/
extern uint8 TempTP[];

/*@ȫֱextern*/
extern uint8* VeDcm_P_DataAddress;                                                          /*TPݵַ*/
extern uint8 VeDcm_u_DL;                                                                    /*TPݳ*/
extern uint8 VeDcm_u_RequstSty;                                                             /*TPʽ*/
extern uint8 VaDcm_u_NegRspTxBuffer[3];
 
extern TsDcm_h_RquestInfo VeDcm_h_RqustInfo;



extern uint16 VeDcm_w_S3ServerTime;                            /*S3ServerTime*/
extern uint8 VeDcm_u_S3ServerTimeSts; 
extern uint8 VeDcm_u_DiagnosticSession;                        /*ϻỰģʽ*/
extern uint8 VeDcm_u_SecurityAccessState;                      /*ȫȨ״̬*/



/******************************************************************************
 * Description:     : Global Function Prototype Declaration	
******************************************************************************/


/*@ӿںextern*/
extern uint8 MngDcm_CollectRequstInfo(void);

extern TeDcm_h_ResultType MngDcm_DefaultSessionDeal(void);
extern TeDcm_h_ResultType MngDcm_ProgramSessionDeal(void);
extern TeDcm_h_ResultType MngDcm_ExtendedSessionDeal(void);

extern TeDcm_h_ResultType MngDcm_SoftResetDeal(void);

extern TeDcm_h_ResultType MngDcm_CleanDTC(uint32 Group);

extern  TeDcm_h_ResultType MngDcm_DynamicaDefineNewDid(void);
extern   TeDcm_h_ResultType MngDcm_ClearDynamicaDid(void);

extern TeDcm_h_ResultType MngDcm_RequestSeekDeal(uint8 SecurityLevel);
extern TeDcm_h_ResultType MngDcm_KeyCkeckDeal(uint8 dummy);

extern  TeDcm_h_ResultType MngDcm_CtrlCommunication(uint8  CommunicationType);
extern TeDcm_h_ResultType MngDcm_DisenableCommunication(void);

extern TeDcm_h_ResultType MngDcm_RoutineFF02Start(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF02Stop(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF02Result(void);

extern TeDcm_h_ResultType MngDcm_RoutineF001Start(void) ; 
extern TeDcm_h_ResultType MngDcm_RoutineF001Stop(void)  ;   
extern TeDcm_h_ResultType MngDcm_RoutineF001Result(void); 


extern TeDcm_h_ResultType MngDcm_TesterPresentDeal(void);

extern TeDcm_h_ResultType MngDcm_DTCSettingEnable(void);
extern TeDcm_h_ResultType MngDcm_DTCSettingDisenable(void);

extern void MngDcm_ChangeToDefaltSession(void);

extern void MngDcmS3ServerCountCutDown(void);

extern void MngDcmKeyErrorDelayCountCutDown(void);

extern void MngDcm_PrepareNegRsp(uint8 Sid,uint8 Nrc);

extern void MngDcm_DataMoveDeal(uint8* TargetAddress,uint8 TargetPost,uint8* SourceAddress,uint8 SourcePost,uint8 DataLength);

extern TeDcm_h_ResultType MngDcm_RequestDownloadService(void);
extern TeDcm_h_ResultType MngDcm_TransmitDataService(void);
extern TeDcm_h_ResultType MngDcm_TransmitExitService(void);

extern void InitDcm_Parameter (void);

extern uint16 MngDcm_GetS3serverTime(void);
extern uint8 MngDcm_GetS3serverTimeSts(void);
extern uint8 MngDcm_GetDiagnosticSession(void);
extern uint8 MngDcm_GetSecurityAccessSts(void);

extern TeDcm_h_ResultType MngDcm_RoutineFF00Start(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF01Start(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF00Stop(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF01Stop(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF00Result(void);
extern TeDcm_h_ResultType MngDcm_RoutineFF01Result(void);

extern  uint8 GetDtcEnable(void);
extern  void CleanIoDid(void);

extern void MngDcm_ResetS3serverTime(void);

extern  void resetS3Server(void);

#endif
