
typedef struct
{
	unsigned char write;
	unsigned char data;
}IO_parameter_t;

#define IO_TEMP      	0
#define IO_REC			1
#define IO_FAN			2
#define IO_MODE			3
#define IO_DEFROST		4
#define IO_REARDEF		5
#define IO_AC			6
#define IO_K30			7

#define KL30_VOLTAGE 	0
#define TEMP_MOTOR		1
#define MODE_MOTOR		2
#define REC_MOTOR		3
#define EVA_SENSOR		4

#define INDEX_REPROGMA  0
#define INDEX_0xF190    1
#define INDEX_0xF198    2
#define INDEX_0xF199    3
#define INDEX_0xF19D    4



#define INDEX_0xF110	5
#define INDEX_0xF197    5
#define INDEX_0xF112    5


/************************************************************************************
//  ch :  																	/		 
//			0: KL30ѹ                     										/			
//          1: ʻԱ¶ȵڵѹ                                         /
//          2: ģʽѹ                                         	/
//          3: ѭŵڵѹ                                             /
//          4¶ȴѹ                                                 /
//                                                                                  /
// ֵ                                                                         /
//          Ӧĵѹ*10صĵѹֵ0.1Vģ                             /
//                                                                                  /
************************************************************************************/ 
unsigned char GetVoltage(unsigned char ch);

/************************************************************************************
//  motor :  																/			
//          1: ʻԱ¶ȵڵ                                         		/
//          2: ģʽ                                        		 		/
//          3: ѭŵڵ                                             		/
//                                                                                  /
// ֵ                                                                         /
//          0:  1ת                             					/
//                                                                                  /  
************************************************************************************/ 
unsigned char GetMotorLockStatus(unsigned char motor);

/************************************************************************************
//  p :  																	/			
// 				0: TEMP 	ʻԱ¶ȷλ 	     							/
// 				1: REC		ѭģʽ		                            		/
// 				2: FAN		ķλ		                            			/
// 				3: MODE		ģʽλ		                            		/
// 				4: DEFROST	˪	                            				/
// 				5: REARDEF	˪	                            				/
// 				6: AC 		A/C䰴	                            			/
// 				7: K30		ECU Supplier voltage  		                            /
//                                                                                  /
// ֵ                                                                         /
//          0: Ӧdata,222F                             				/
************************************************************************************/
unsigned char GetIoParameter(unsigned char p);

/************************************************************************************
//  p :  																	/			
// 				0: TEMP 	ʻԱ¶ȷλ 	     							/
// 				1: REC		ѭģʽ		                            		/
// 				2: FAN		ķλ		                            			/
// 				3: MODE		ģʽλ		                            		/
// 				4: DEFROST	Ч	                            					/
// 				5: REARDEF	˪	                            				/
// 				6: AC 		Ч	                            					/
// 				7: K30		Ч  		                            				/
// ֵ                                                                         /
//                                        											/
************************************************************************************/
void WriteIoParameter(unsigned char p,unsigned char data);

/************************************************************************************
//  p :  																	/			
//                                                   								/
//                                                                                  /
// ֵ                                                                         /
//          0: IGNԴ     1IGN > 16V  IGN < 9V                         	/
//                                                                                  /
************************************************************************************/
unsigned char GetIgnVoltStatus(void);

/************************************************************************************
//  ID :  		CAN ID														//	
//  Dlc :  		CAN ݳ											//		
//  *Data :  	ָ CAN ݻָ								//	
// 				                		                            				//
// ֵ                                                                         //
//         0 ͳɹ  0 ʧ                               				//
************************************************************************************/
unsigned char TransmitCAN_Message(unsigned int ID,unsigned char Dlc,unsigned char *Data);

/************************************************************************************
//  write_buf :  	ָ Ҫдݻĵַ							//	
//  data_num :  	ݴ												//		
//  len :  			дݳ											//	
// 				                		                            				//
// ֵ                                                                         //
//         0 дɹ  0 дʧ                               				//
************************************************************************************/
unsigned char DF_Write(unsigned char* write_buf,unsigned char data_num,unsigned char len);

/************************************************************************************
//  read_buf :  	ָȡݴĻĵַ							//	
//  data_num :  	ݴ												//		
//  len :  			ȡݳ											//	
// 				                		                            				//
// ֵ                                                                         //
//         0 ȡɹ  0 ȡʧ                               				//
************************************************************************************/
unsigned char DF_Read(unsigned char* read_buf,unsigned char data_num,unsigned char len);

/************************************************************************************
// 				                		                            				//
// ֵ                                                                         //
//         ǰ32bit  1msֵ                               					//
***********************************************************************************/
unsigned long GetTimerCnt(void);

/************************************************************************************
// ȡdata Flashݴȡ														//
//  code :  																//			
//			0  : ȡAPPر־											//
//			1  : ȡ2E0xF110                                            //
//			2  : ȡ2E0xF190                                            //
//			3  : ȡ2E0xF197                                            //
//			4  : ȡ2E0xF198                                            //
//			5  : ȡ2E0xF199                                            //
//			6  : ȡ2E0xF19D                                    		//		
//			7  : ȡ2E0xF112											//
//			8  : ȡ190xF00616                                            //
//			9  : ȡ190xF00617                                            //
//			10 : ȡ190x918112                                            //
//			11 : ȡ190x918114                                            //
//			12 : ȡ190x918171                                            //
//			13 : ȡ190x918312                                    		//		
//			14 : ȡ190x918314											//
//			15 : ȡ190x918371                                            //
//			16 : ȡ190x918412                                            //
//			17 : ȡ190x918414                                            //
//			18 : ȡ190x918471                                            //
//			19 : ȡ190x918611                                            //
//			20 : ȡ190x918614                                    		//		
//			21 : ȡ190xC07300
//                                                                                  //
// ֵ                                                                         //
//                                   								//
//                                                                                  //
************************************************************************************/
unsigned char GetIndexNumber(unsigned char code);

/************************************************************************************
// ȡACӲ汾																	//
//  hdv :  																	//			
//			ָȡݴĻĵַ											//	
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/
void GetHardwareVersion(unsigned char* hdv);

/************************************************************************************
// ȡAC汾																	//
//  swv :  																	//			
//			ָȡݴĻĵַ											//	
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/
void GetSoftwareVersion(unsigned char* swv);


/************************************************************************************
// ȡAC																	//
//  *date :  																//			
//			data[0] = YEAR															//	
//			data[1] = MONTH															//	
//			data[0] = DAY															//	
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/
void GetManufacturingDate(unsigned char* date);

/************************************************************************************
// ȡCan߳״̬																//
//  																		//			
//                                                                                  //
// ֵ Can߳״̬			                                                  //
//                                                  								//
//                                                                                  //
************************************************************************************/
unsigned char GetCanBusOffErr(void);

/************************************************************************************
// ȡʷɹ̴																	//
//  																		//			
//                                                                                  //
// ֵ ʷɹ̴                                                           //
//                                                  								//
//                                                                                  //
************************************************************************************/
unsigned char GetProgrammingCounter(void);

/************************************************************************************
// ȡʷ̴																	//
//  																		//			
//                                                                                  //
// ֵ ʷ̴                                                           //
//                                                  								//
//                                                                                  //
************************************************************************************/
unsigned char GetProgrammingAttempCounter(void);

/************************************************************************************
// DTC																	//
//  																		//			
//                                                                                  //
// ֵ ״̬                                                           //
//                                                  								//
//                                                                                  //
************************************************************************************/
unsigned char Clear_DTC_Data(void);

