/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2021 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_userdefine.h
* Version      : CodeGenerator for RL78/F13 V2.03.07.02 [08 Nov 2021]
* Device(s)    : R5F10BGG
* Tool-Chain   : CCRL
* Description  : This file includes user definition.
* Creation Date: 2024/7/7
***********************************************************************************************************************/

#ifndef _USER_DEF_H
#define _USER_DEF_H

/***********************************************************************************************************************
User definitions
***********************************************************************************************************************/

/* Start user code for function. Do not edit comment generated here */

typedef struct{
	uint8_t RspData[8];
	uint8_t	AckReq;
	uint8_t	AckLenth;
	uint8_t boot_enable;
	uint8_t RunAir;
	uint8_t RstSrc;
	uint8_t KeyErrTimes;
	uint8_t SeedReqTimes;
}KamData_t;

#define WDT_RST	0x10
#define RPRGRM_REQ_VALID 0xA5
#define RUN_IN_BOOT		 0x00
#define RUN_IN_APP		 0xA5
#define ACK_REQ			 0xA5

#define GetAppValid()	(*(__far uint32 *)0xA100)
#define GetAppEndValid()	(*(__far uint32 *)0x19FF0)

#define DID_0200_ADDR	0x1A000
#define DID_0201_ADDR	0x1A008

#define DID_F180_ADDR	0x19C20
#define DID_F193_ADDR	0x19C00

#define DIAGNOSE_STD_V_H	(0x03) 		/*	ͻϱ׼汾 */
#define DIAGNOSE_STD_V_L	(0x02)

#define DIAGNOSE_PARAMETER_V_H	(0x01)	/* ϵ汾 */
#define DIAGNOSE_PARAMETER_V_L	(0x08)

extern KamData_t KamData;

void hdwinit(void);
void CAN_Pin_init(void);

/* End user code. Do not edit comment generated here */
#endif
